\\ Copyright 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
read("configurations.gp");


\\-----------------------------------------------------------------------------
\\ 

\\ left point, 0,1,2,3,4 pairs
{
  2 * (                        \\ triangle 9 arbitrary

  \\ both or neither 1,2
  + 2 *
  sum(other=0,3,
      binomial(3,other)      \\ left enter
      * binomial(3,other)     \\ left exit
     )
  ^ 2                         \\ right side independently

  \\ 1 not 2 or 2 not 1
  + 2 *
  sum(other=0,3,
      binomial(3,other)        \\ left enters
      * binomial(3,other+1)    \\ left exits
     )
  ^ 2                         \\ right side independently

  )
  + 13                        \\ single-segment confs other than 1,2
}

conf_num_left_enter(conf)  = conf[1] + conf[3] + conf[5] + conf[7];
conf_num_left_exit(conf)   = conf[2] + conf[4] + conf[6] + conf[8];
conf_num_right_enter(conf) = conf[12] + conf[14] + conf[2] + conf[10];
conf_num_right_exit(conf)  = conf[13] + conf[15] + conf[1] + conf[11];

binary_padded(n,k) =  \
  my(v = binary(n)); \
  concat(vector(max(0,k-#v)),v);

conf_validate(conf) =
{
  if(vecsum(conf)<=1, return(1));
  conf_num_left_enter(conf) == conf_num_left_exit(conf)
  && conf_num_right_enter(conf) == conf_num_right_exit(conf);
}
  
{
  my(count = 0);
  for(i=1,2^15-1,
     my(conf=binary_padded(i,15));
     if(conf_validate(conf), count++));
  count
}
     
